# Copyright 2018-present Lenovo
# Confidential and Proprietary

import tensorflow as tf

from factory import create_app

if __name__ == 'deploy_service':
    gun_args = ['workers', 'bind', 'pythonpath', 'access-logfile',
                'error-logfile', 'env', 'timeout']
    for param in gun_args:
        tf.app.flags.DEFINE_string(param, '', '')
    inf_app = create_app()


if __name__ == '__main__':
    tf.app.flags.DEFINE_enum(
        'scenario', 'classification',
        ['classification', 'objectdetection', 'segmentation'],
        "Scenario for this service"
    )
    tf.app.flags.DEFINE_string(
        'url', '/api/service', 'URL used to access the deployed service'
    )
    tf.app.flags.DEFINE_string('deploy_path', '', "deploy service path")
    tf.app.flags.DEFINE_string(
        'lico_model_path', '', "model path, for inference job"
    )
    tf.app.flags.DEFINE_string(
        'lico_image_file', '', "image file to deal, for inference job"
    )
    tf.app.flags.DEFINE_string(
        'lico_output_dir', '', "output dir, for inference job"
    )
    tf.app.flags.DEFINE_string('model_name', '',
                               "model_name of the deployed service")
    tf.app.flags.DEFINE_integer(
        'port', 60000, 'HTTP server port for the deployed service'
    )
    tf.app.flags.DEFINE_string(
        'service_uuid', '',
        'Deployed service which would be add to URI'
    )
    FLAGS = tf.app.flags.FLAGS

    from os.path import dirname
    from subprocess import check_call

    cmd = [
        'gunicorn',
        '--workers',
        '1',
        '--bind',
        '0.0.0.0:{0}'.format(FLAGS.port),
        '--pythonpath',
        dirname(__file__),
        '--access-logfile',
        '-',
        '--error-logfile',
        '-',
        '--timeout',
        '600',
        '--env',
        'LETRAIN_SCENARIO={0}'.format(FLAGS.scenario),
        '--env',
        'LETRAIN_MODEL_PATH={0}'.format(FLAGS.deploy_path),
        '--env',
        'LETRAIN_MODEL_NAME={0}'.format(FLAGS.model_name),
        '--env',
        'SERVICE_UUID={0}'.format(FLAGS.service_uuid),
        '--env',
        'SERVICE_URL={0}'.format(FLAGS.url),
        'deploy_service:inf_app'
    ]
    check_call(cmd)
